#include <memory.h>
#include <string.h>

#include "auth.h"

int
passtokey (char *key, char *p)
{
	unsigned char buf[NAMELEN], *t;
	int i, n;

	n = strlen (p);
	if (n >= NAMELEN)
		n = NAMELEN - 1;

	memset (buf, ' ', 8);
	t = buf;
	strncpy (t, p, n);
	t[n] = 0;
	memset (key, 0, DESKEYLEN);

	while (1) {
		for (i = 0; i < DESKEYLEN; i++)
			key[i] = (t[i] >> i) + (t[i+1] << (8 - (i + 1)));
		if (n <= 8)
			break;
		n -= 8;
		t += 8;
		if (n < 8) {
			t -= 8 - n;
			n = 8;
		}
		plan9_encrypt (key, t, 8);
	}

	return (1);
}
